from Tkinter import *
from Gui import *
from Input import *
from Tree import *

import sys

import ctypes

INPUT = 1

class keyboard(Tk):
	def __init__(self, debug=False):
		# initiallization
		self.debug = debug
		self.frame = self
		self.frames = []
		self.inputSystem = 0;

		usb = ctypes.cdll.LoadLibrary('usb.dll')
		self.usb = usb
		self.usb.initialize()
		
		buffer = ctypes.c_buffer(8)
		self.buffer = buffer

		# make GUI
		self.g = Gui(debug = False)
		self.g.title('T9 Keyboard GUI')

		self.g.row()

		# FRAME 1
		
		self.g.col()
		wordlist = ['a','an','but']

		# the entrybox
		entrybox = self.g.en()
		self.entrybox = entrybox
		self.g.bu(text = 'INPUT', command=self.input_callback)

		# the list of possible words
		possiblewords = self.g.lb()
		for item in wordlist:
			possiblewords.insert(END,item)
		self.possiblewords = possiblewords

		self.g.endcol()


		# FRAME 2

		self.g.fr(side=LEFT)

		# scrollable text widget
		textbox = self.g.st(side=TOP)
		self.textbox = textbox
		self.textbox.text.configure(height=20, width=40)
		self.textbox.text.insert(END, "This is a Scrollable Text widget.\n")

		selectall = self.g.bu(text="Copy all", command=self.doSelectAll)

		r = Tree('-1')
		self.r = r
		myappWord = Input(r,'input.txt')
		self.myappWord = myappWord

		self.temp = "hi"

		self.g.endfr()

		# calling part
		dev = self.usb.open_device(0x6666, 0x0003)
		self.dev = dev
		if self.dev<0:
			print "No matching device found...\n"
		else:
			#print 'hi'
			ret = self.usb.control_transfer(self.dev, 0x00, 0x09, 1, 0, 0, self.buffer)
			if ret<0:
				print "Unable to send SET_CONFIGURATION standard request.\n"
			self.g.after(50, self.update_status)
			self.g.mainloop()
			self.usb.close_device(self.dev)

	#function
	def input_callback(self):
		self.usb.control_transfer(self.dev, 0xC0, INPUT, 0, 0, 1, self.buffer);
		#self.status.configure(text = 'current input %d.' % ord(self.buffer[0]) )
		if(ord(self.buffer[0])!=0):
			self.getWord( ord(self.buffer[0]) )

	def update_status(self):
		self.usb.control_transfer(self.dev, 0xC0, INPUT, 0, 0, 1, self.buffer)
		#self.status.configure(text = 'current input %d.' % ord(self.buffer[0]) )
		if(ord(self.buffer[0])!=0):
			self.getWord( ord(self.buffer[0]) )
		self.g.after(50, self.update_status)

	def doSelectAll(self):
		self.g.clipboard_clear()
		self.g.clipboard_append(self.textbox.text.get(2.0,END))

	def getWord(self, value):
		if(value == 6):
			self.select_word()
			return

		wordlist = []

		if(value == 5):
			self.change_word()
			return

		self.possiblewords.delete(0,END)

		if(value == 11):
			wordlist = self.delete_word()
		elif(value == 12):
			wordlist = self.caps_lock()
		else:
			currentword = self.entrybox.get()
			currentword = currentword+str(value%10)
			self.entrybox.delete(0,END)
			self.entrybox.insert(0,currentword)
			wordlist = self.myappWord.appWord(currentword,self.r,self.inputSystem)
													
		for item in wordlist:
			self.possiblewords.insert(END, item)

		print value

	def change_word(self):
		self.possiblewords.insert(END, self.possiblewords.get(0))
		self.possiblewords.delete(0)
	
	def delete_word(self):
		currentword = self.entrybox.get()
		currentword = currentword[:-1]

		# Allen's change #1
		# delete the current contents before adding the new letters
		# see http://effbot.org/tkinterbook/entry.htm for more
		# info
		self.entrybox.delete(0, END)
		self.entrybox.insert(0,currentword)
		
		wordlist = []
		wordlist = self.myappWord.appWord(currentword,self.r,self.inputSystem)
		
		return wordlist
		
	def caps_lock(self):
		self.inputSystem = (self.inputSystem+1) %5

		if(self.inputSystem == 4):
			wordlist = ["'",".",",","_","?","(",")","="]

		else:
			currentword = self.entrybox.get()
			wordlist = []
			wordlist = self.myappWord.appWord(currentword,self.r,self.inputSystem)
		
		return wordlist

	def select_word(self):
		if(self.inputSystem == 4):
			self.temp = self.possiblewords.get(0)
			self.textbox.text.insert(END, self.temp )
			self.inputSystem = 0;
		else:
			print self.temp
			if(self.temp != "'"):
				self.textbox.text.insert(END, " ")
			self.temp =self.possiblewords.get(0)
			self.textbox.text.insert(END, self.temp)
		self.entrybox.delete(0,END)
		self.possiblewords.delete(0,END)
	
				  
g=keyboard()
