import sys
from Tkinter import *
from Gui import *
from Input import *
from Tree import *

"""demonstrate a variety of widgets"""

class keyboardinterface(Tk):
	def __init__(self, debug=False):
		"""initialize the gui.
		turning on debugging changes the behavior of Gui.fr so
		that the nested frame structure is apparent.

		(debug) is a boolean that makes Frames visible if True.
		(frame) is the current Frame.
		(frames) is the stack of pending Frames.
		"""
		#~ Tk.__init__(self)
		self.debug = debug
		self.frame = self
		self.frames = []
		self.inputSystem = 0

		g = Gui(debug=False)
		g.row()

		# FRAME 1

		g.col()

		wordlist = ['a','an','but']

		#the entry box
		entrybox = g.en()
		self.entrybox = entrybox
		self.entrybox.bind('<Key>', self.onkey_normal)
		refresh = g.bu(text="INPUT", command=self.select_word)
		

		#the list of possible words
		possiblewords = g.lb()
		for item in wordlist:
				possiblewords.insert(END,item)
		
		self.possiblewords=possiblewords

		g.endcol()


		# FRAME 2
		g.fr(side=LEFT)

		# scrollable text widget
		textbox = g.st(side=TOP)
		self.textbox = textbox
		self.textbox.text.configure(height=20, width=40)
		self.textbox.text.insert(END, "Try out our GUI!\n1-4 and 7-0 type letters.\nPress 5 to scroll, 6 to enter,\na to delete and b to switch modes.\n")
		

		selectall = g.bu(text="Select all", command=self.doSelectAll)
		
		r = Tree('-1')
		self.r = r
		myappWord = Input(r, 'input.txt')
		self.myappWord = myappWord
		
		g.endfr()

		self.g = g

		self.g.mainloop()

	def doSelectAll(self):
		self.g.clipboard_clear()
		self.g.clipboard_append(self.textbox.text.get(2.0,END))

	def get_current_word(self):
		currentword = self.entrybox.get()
		print currentword
	
	def change_word(self):
		self.possiblewords.insert(END, self.possiblewords.get(0))
		self.possiblewords.delete(0)
	
	def delete_word(self):
		currentword = self.entrybox.get()
		currentword = currentword[:-1]

		# Allen's change #1
		# delete the current contents before adding the new letters
		# see http://effbot.org/tkinterbook/entry.htm for more
		# info
		self.entrybox.delete(0, END)
		self.entrybox.insert(0,currentword)
		
		wordlist = []
		wordlist = self.myappWord.appWord(currentword,self.r,self.inputSystem)
		
		return wordlist
		
	def caps_lock(self):
		self.inputSystem = (self.inputSystem+1) %5

		if(self.inputSystem == 4):
			wordlist = ["'",".",",","_","?","(",")","="]

		else:
			currentword = self.entrybox.get()
			wordlist = []
			wordlist = self.myappWord.appWord(currentword,self.r,self.inputSystem)
		return wordlist

	def select_word(self):
		temp = self.possiblewords.get(0)
		if(self.inputSystem == 4):
			self.textbox.text.insert(END, temp)
			self.inputSystem = 0;
		else:
			if(temp != "'"):
				self.textbox.text.insert(END, " ")
			temp =self.possiblewords.get(0)
			self.textbox.text.insert(END, temp)
		self.entrybox.delete(0,END)
		self.possiblewords.delete(0,END)

	def onkey_normal(self, event):
		if(event.char == '6'):
			self.select_word()
			return 'break'

		wordlist = []

		if(event.char == '5'):
			self.change_word()
			return 'break'

		self.possiblewords.delete(0,END)
				
		if(event.char == 'a'):
			wordlist = self.delete_word()
		elif(event.char == 'b'):
			wordlist = self.caps_lock()
		else:
			currentword = self.entrybox.get()
			wordlist = self.myappWord.appWord(currentword+str(event.char),self.r,self.inputSystem)
		
		for item in wordlist:
			self.possiblewords.insert(END, item)

		print event.char
	
		if event.char == 'a':
			return 'break'
		if event.char == 'b':
			return 'break'
			  #  print currentword + event.char

g = keyboardinterface()
